## fixme: add documentation

import _ahocorasick


__all__ = ['KeywordTree']



class KeywordTree(_ahocorasick.KeywordTree):

## Most of the methods here are just delegated over to the underlying
## C KeywordTree.  But we add a few more convenience functions here.

    def chases(self, sourceStream):
        for block in sourceStream:
            for match in self.findall(block):
                yield (block, match)


    def findall(self, sourceBlock):
        """Returns all the search matches in the source block."""
        startpos = 0
        while True:
            match = self.search(sourceBlock, startpos)
            if not match:
                break
            yield match
            startpos = match[1]
        
        
    def chases_long(self, sourceStream):
        for block in sourceStream:
            for match in self.findall_long(block):
                yield (block, match)


    def findall_long(self, sourceBlock):
        """Returns all the search matches in the source block."""
        startpos = 0
        while True:
            match = self.search_long(sourceBlock, startpos)
            if not match:
                break
            yield match
            startpos = match[1]

